#version 460

// uniforms
uniform vec4 l_dir; // world space
uniform	mat4 m_pvm;
uniform mat4 m_view;
uniform	mat3 m_normal;


in vec4 position;
in vec3 normal;

out float i;

void main() {
	// transform and normalise both vectors
	vec3 n = normalize(m_normal * normal);

    // convert l_dir to camera space and normalize
    vec3 l = normalize(vec3(m_view * -l_dir));

    // compute the intensity using the dot operation
	i = max(0.0, dot(n, l));

	gl_Position = m_pvm * position;
}