#version 150

// uniforms
uniform mat4 m_view;
uniform vec4 l_dir; // global space

uniform	vec4 diffuse;
uniform float threshold1 = 0.25;
uniform float threshold2 = 0.50;
uniform float threshold3 = 0.75;
uniform float threshold4 = 0.90;

//input
in vec3 n;

//output
out vec4 color;


void main() {

	// get light dir in camera space
	vec3 ld = normalize(vec3(m_view * -l_dir));

	// compute the intensity using the dot operation
	float i = max(0.0, dot(n, ld));

	// compute the color based on the intensity
    float intensity;
    if (i < threshold1)
        intensity = threshold1;
    else if (i < threshold2)
        intensity = threshold2;
    else if (i < threshold3)
        intensity = threshold3;
    else
        intensity = threshold4;

    color = diffuse * intensity;

		
}
