#version 460

// uniform
uniform vec4 l_dir; // world space
uniform mat4 m_view;

uniform vec4 diffuse;
uniform float threshold1 = 0.25;
uniform float threshold2 = 0.50;
uniform float threshold3 = 0.75;
uniform float threshold4 = 0.90;


// input
in vec3 n;

//output
out vec4 color;

void main() {

    vec3 nn = normalize(n);
    // convert l_dir to camera space and normalize
    vec3 l = normalize(vec3(m_view * -l_dir));

    float i = max(0.0, dot(nn,l));

    float intensity = i;

    if (i < threshold1)
        intensity = threshold1;
    else if (i < threshold2)
        intensity = threshold2;
    else if (i < threshold3)
        intensity = threshold3;
    else
        intensity = threshold4;

    color = diffuse * intensity;
}